diff -urN p2ex-050511-0402.orig/p2/lib/showthreadk.class.php p2ex-050511-0402.P007_mmobbs/p2/lib/showthreadk.class.php
--- p2ex-050511-0402.orig/p2/lib/showthreadk.class.php	2005-05-11 04:02:36.000000000 +0900
+++ p2ex-050511-0402.P007_mmobbs/p2/lib/showthreadk.class.php	2005-05-12 19:20:16.000000000 +0900
@@ -40,10 +40,13 @@
         // URLnho^
         $this->url_handlers = array(
             array('this' => 'plugin_link2ch'),
+            array('this' => 'plugin_linkmmobbs'),
             array('this' => 'plugin_linkMachi'),
             array('this' => 'plugin_linkJBBS'),
             array('this' => 'plugin_link2chKako'),
             array('this' => 'plugin_link2chSubject'),
+            array('this' => 'plugin_linkmmobbsKako'),
+            array('this' => 'plugin_linkmmobbsSubject'),
         );
         if (P2_IMAGECACHE_AVAILABLE == 2) {
             $this->url_handlers[] = array('this' => 'plugin_imageCache2');
@@ -719,6 +722,48 @@
     }
 
     /**
+     * mmobbs  N
+     */
+    function plugin_linkmmobbsSubject($url, $purl, $str)
+    {
+        global $_conf, $_exconf;
+
+        if (preg_match('{^http://(\\w+\\.(?:mmobbs\\.com))/([^/]+)/$}', $url, $m)) {
+            $subject_url = "{$_conf['subject_php']}?host={$m[1]}&amp;bbs={$m[2]}";
+            return "<a href=\"{$url}\">{$str}</a> [<a href=\"{$subject_url}{$_conf['k_at_a']}\">p2ŊJ</a>]";
+        }
+        return FALSE;
+    }
+
+    /**
+     * mmobbs  XbhN
+     */
+    function plugin_linkmmobbs($url, $purl, $str)
+    {
+        global $_conf, $_exconf;
+
+        if (preg_match('{^http://(\\w+\\.(?:mmobbs\\.com))/test/read\\.cgi/([^/]+)/([0-9]+)(?:/([^/]+)?)?$}', $url, $m)) {
+            $read_url = "{$_conf['read_php']}?host={$m[1]}&amp;bbs={$m[2]}&amp;key={$m[3]}&amp;ls={$m[4]}";
+            return "<a href=\"{$read_url}{$_conf['k_at_a']}\">{$str}</a>";
+        }
+        return FALSE;
+    }
+
+    /**
+     * mmobbs@ߋOhtml
+     */
+    function plugin_linkmmobbsKako($url, $purl, $str)
+    {
+         global $_conf, $_exconf;
+
+        if (preg_match('{^http://(\\w+(?:\\.mmobbs\\.com))(?:/[^/]+/)?/([^/]+)/kako/\\d+(?:/\\d+)?/(\\d+)\\.html$}', $url, $m)) {
+            $read_url = "{$_conf['read_php']}?host={$m[1]}&amp;bbs={$m[2]}&amp;key={$m[3]}&amp;kakolog=" . rawurlencode($url);
+            return "<a href=\"{$read_url}{$_conf['k_at_a']}\">{$str}</a>";
+        }
+        return FALSE;
+    }
+
+    /**
      * ܂BBS / JBBS  N
      */
     function plugin_linkMachi($url, $purl, $str)
diff -urN p2ex-050511-0402.orig/p2/lib/showthreadpc.class.php p2ex-050511-0402.P007_mmobbs/p2/lib/showthreadpc.class.php
--- p2ex-050511-0402.orig/p2/lib/showthreadpc.class.php	2005-05-11 04:02:36.000000000 +0900
+++ p2ex-050511-0402.P007_mmobbs/p2/lib/showthreadpc.class.php	2005-05-12 19:28:56.000000000 +0900
@@ -52,10 +52,13 @@
         // URLnho^
         $this->url_handlers = array(
             array('this' => 'plugin_link2ch'),
+            array('this' => 'plugin_linkmmobbs'),
             array('this' => 'plugin_linkMachi'),
             array('this' => 'plugin_linkJBBS'),
             array('this' => 'plugin_link2chKako'),
             array('this' => 'plugin_link2chSubject'),
+            array('this' => 'plugin_linkmmobbsKako'),
+            array('this' => 'plugin_linkmmobbsSubject'),
         );
         if (P2_IMAGECACHE_AVAILABLE == 2) {
             $this->url_handlers[] = array('this' => 'plugin_imageCache2');
@@ -1182,6 +1185,60 @@
     }
 
     /**
+     * mmobbs  N
+     */
+    function plugin_linkmmobbsSubject($url, $purl, $str)
+    {
+        global $_conf, $_exconf;
+
+        if (preg_match('{^http://(\\w+\\.(?:mmobbs\\.com))/([^/]+)/$}', $url, $m)) {
+            $subject_url = "{$_conf['subject_php']}?host={$m[1]}&amp;bbs={$m[2]}";
+            return "<a href=\"{$url}\" target=\"subject\">{$str}</a> [<a href=\"{$subject_url}\" target=\"subject\">p2ŊJ</a>]";
+        }
+        return FALSE;
+    }
+
+    /**
+     * mmobbs  XbhN
+     */
+    function plugin_linkmmobbs($url, $purl, $str)
+    {
+        global $_conf, $_exconf;
+
+        if (preg_match('{^http://(\\w+\\.(?:mmobbs\\.com))/test/read\\.cgi/([^/]+)/([0-9]+)(?:/([^/]+)?)?$}', $url, $m)) {
+            $read_url = "{$_conf['read_php']}?host={$m[1]}&amp;bbs={$m[2]}&amp;key={$m[3]}&amp;ls={$m[4]}";
+            if ($_conf['iframe_popup']) {
+                if (preg_match('/^[0-9n\\-]+$/', $m[4])) {
+                    $pop_url = $url;
+                } else {
+                    $pop_url = $read_url . '&amp;one=true';
+                }
+                return $this->iframe_popup(array($read_url, $pop_url), $str, $_conf['bbs_win_target_at']);
+            }
+            return "<a href=\"{$read_url}\"{$_conf['bbs_win_target_at']}>{$str}</a>";
+        }
+        return FALSE;
+    }
+
+    /**
+     * mmobbs ߋOhtml
+     */
+    function plugin_linkmmobbsKako($url, $purl, $str)
+    {
+        global $_conf, $_exconf;
+
+        if (preg_match('{^http://(\\w+(?:\\.mmobbs\\.com))(?:/[^/]+/)?/([^/]+)/kako/\\d+(?:/\\d+)?/(\\d+)\\.html$}', $url, $m)) {
+            $read_url = "{$_conf['read_php']}?host={$m[1]}&amp;bbs={$m[2]}&amp;key={$m[3]}&amp;kakolog=" . rawurlencode($url);
+            if ($_conf['iframe_popup']) {
+                $pop_url = $read_url . '&amp;one=true';
+                return $this->iframe_popup(array($read_url, $pop_url), $str, $_conf['bbs_win_target_at']);
+            }
+            return "<a href=\"{$read_url}\"{$_conf['bbs_win_target_at']}>{$str}</a>";
+        }
+        return FALSE;
+    }
+
+    /**
      * ܂BBS / JBBS  N
      */
     function plugin_linkMachi($url, $purl, $str)
